#if !defined (___FrameBuffer_hpp___)
#define ___FrameBuffer_hpp___



class Image;

class FrameBuffer
{
    public:
        FrameBuffer();
        ~FrameBuffer();

    public:
        bool Destroy(bool result = true);
        bool Create(int width, int height);

        void BlitToWindow(HDC hDstDC, int dstWidth, int dstHeight);

        void HLine(int y);
        void VLine(int x);
        void Fill(int x1, int y1, int x2, int y2);
        void FillXor(double xOffset, double yOffset);

        void Clear(unsigned int color);

    private:
        COLORREF Color(unsigned int color);

    private:
public:
        HDC                 m_hDC;
        BITMAPINFO          m_bmi;
        HBITMAP             m_hDibSection;
        unsigned char *     m_pBits;
        int                 m_width;
        int                 m_height;
        int                 m_pitch;
};

#endif // ___FrameBuffer_hpp___